/*
 * ServerAddins.cpp.in
 *
 * Copyright (C) 2022 by Posit Software, PBC
 *
 * Unless you have received this program directly from Posit Software pursuant
 * to the terms of a commercial license agreement with Posit Software, then
 * this program is licensed to you under the terms of version 3 of the
 * GNU Affero General Public License. This program is distributed WITHOUT
 * ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
 * AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
 *
 */

#include <shared_core/Error.hpp>
#include <core/Exec.hpp>

using namespace rstudio::core;

namespace rstudio {
namespace server {
namespace addins {
  


namespace {

Error dummyInit()
{
   return Success();
}

}

Error initialize()
{
   ExecBlock initBlock;
   initBlock.addFunctions()
      
      (dummyInit);

   return initBlock.execute();
}


} // namespace addins
} // namespace server
} // namespace rstudio

